#ifndef __USBCOM_H__
#define __USBCOM_H__
#include "hal_usb.h"


#define UART_BUFFER_SIZE 64		 // This must be a power of two
#define UART_BUFFER_MODULO (UART_BUFFER_SIZE - 1)  
typedef enum eBufferStates {BUFFER_EMPTY, BUFFER_HAS_DATA, BUFFER_FULL};

typedef struct {
  uint8_t buffer[UART_BUFFER_SIZE];
  uint8_t pos_in;
  uint8_t pos_out;
  uint8_t size; 
}tRingBuffer;


#define UART_DTR 0x01
#define UART_RTS 0x02

typedef struct {
	uint32_t baudrate;
	uint8_t stopbit;
	uint8_t parity;
	uint8_t databit;
} hal_usb_uart_line_coding_t;



extern data tRingBuffer uart_tx_buffer;
extern bit cs_Line_State_Update;	// update line state
extern volatile bit uart_DTR;				// Line status output
extern volatile bit uart_RTS;
extern xdata hal_usb_uart_line_coding_t usb_uart_line_coding;

void CS_Get_Line_Coding();
hal_usb_dev_req_resp_t usb_uart_device_req_proc(hal_usb_device_req* req, uint8_t** data_ptr, uint16_t* size, hal_usb_dev_req_resp_t *retval);
void usb_uart_set_line_state(uint8_t state);

void usb_uart_flush_buffers();
void usb_uart_buffer_clear( tRingBuffer *buf );
uint8_t usb_uart_buffer_put( tRingBuffer *buf, uint8_t a_Byte );
uint8_t usb_uart_buffer_put_array( tRingBuffer *buf, uint8_t *array, uint8_t size );
uint8_t usb_uart_buffer_get( tRingBuffer *buf );
uint8_t usb_uart_buffer_status( tRingBuffer *buf );
#endif